---
title: Firefox 35 for developers
slug: Mozilla/Firefox/Releases/35
tags:
  - Firefox
  - Releases
---
<div>{{FirefoxSidebar}}</div>

<div><span class="seoSummary">Firefox 35 was released on January 13th, 2015. This article lists key changes that are useful not only for web developers, but also Firefox and Gecko developers as well as add-on developers.</span></div>

<h2 id="Changes_for_Web_developers">Changes for Web developers</h2>

<h3 id="Developer_Tools">Developer Tools</h3>

<p>Highlights:</p>

<ul>
 <li><a href="/en-US/docs/Tools/Page_Inspector#.3A.3Abefore_and_.3A.3Aafter">See ::before and ::after pseudo elements in the Page Inspector</a></li>
 <li><a href="/en-US/docs/Tools/Style_Editor#Source_map_support">CSS source maps are now enabled by default</a></li>
 <li><a href="/en-US/docs/Tools/Page_Inspector#Element_popup_menu_2">"Show DOM Properties" from the Page Inspector</a></li>
</ul>

<p><a class="external-icon external" href="https://bugzilla.mozilla.org/buglist.cgi?resolution=FIXED&amp;chfieldto=2014-10-13&amp;chfield=resolution&amp;query_format=advanced&amp;chfieldfrom=2014-09-02&amp;chfieldvalue=FIXED&amp;component=Developer%20Tools&amp;component=Developer%20Tools%3A%203D%20View&amp;component=Developer%20Tools%3A%20Canvas%20Debugger&amp;component=Developer%20Tools%3A%20Console&amp;component=Developer%20Tools%3A%20Debugger&amp;component=Developer%20Tools%3A%20Framework&amp;component=Developer%20Tools%3A%20Graphic%20Commandline%20and%20Toolbar&amp;component=Developer%20Tools%3A%20Inspector&amp;component=Developer%20Tools%3A%20Memory&amp;component=Developer%20Tools%3A%20Netmonitor&amp;component=Developer%20Tools%3A%20Object%20Inspector&amp;component=Developer%20Tools%3A%20Profiler&amp;component=Developer%20Tools%3A%20Responsive%20Mode&amp;component=Developer%20Tools%3A%20Scratchpad&amp;component=Developer%20Tools%3A%20Source%20Editor&amp;component=Developer%20Tools%3A%20Storage%20Inspector&amp;component=Developer%20Tools%3A%20Style%20Editor&amp;component=Developer%20Tools%3A%20Timeline&amp;component=Developer%20Tools%3A%20User%20Stories&amp;component=Developer%20Tools%3A%20Web%20Audio%20Editor&amp;component=Developer%20Tools%3A%20WebGL%20Shader%20Editor&amp;component=Developer%20Tools%3A%20WebIDE&amp;component=Simulator&amp;product=Firefox&amp;product=Firefox%20OS&amp;list_id=11184176">All devtools bugs fixed between Firefox 34 and Firefox 35</a>.</p>

<h3 id="CSS">CSS</h3>

<ul>
 <li>The {{cssxref("mask-type")}} property has been activated by default ({{bug(1058519)}}).</li>
 <li>The {{cssxref("filter")}} property is now activated by default ({{bug(1057180)}}).</li>
 <li>The {{cssxref("@font-face")}} at-rule now supports WOFF2 fonts ({{bug(1064737)}}).</li>
 <li>The {{cssxref("symbols()")}} functional notation is now supported ({{bug(966168)}}).</li>
 <li>The CSS Font Loading API has been implemented ({{bug(1028497)}}).</li>
 <li><span id="summary_alias_container"><span id="short_desc_nonedit_display">Using {{cssxref("-moz-appearance")}} with the <code>none</code> value on a combobox now remove the dropdown button</span></span> ({{bug(649849)}}).</li>
 <li>The property accessor <code>element.style["css-property-name"]</code> has been added to match other browsers ({{bug(958887)}}).</li>
</ul>

<h3 id="HTML">HTML</h3>

<ul>
 <li>The obsolete and non-conforming <code>bottommargin</code>, <code>leftmargin</code>, <code>rightmargin</code> and <code>topmargin</code> attributes of the {{HTMLElement("body")}} element have been activated in non-quirks mode ({{bug(95530)}}).</li>
</ul>

<h3 id="JavaScript">JavaScript</h3>

<ul>
 <li>The "<a href="/en-US/docs/Web/JavaScript/Reference/Statements/let#Temporal_dead_zone_and_errors_with_let">temporal dead zone</a>" for <a href="/en-US/docs/Web/JavaScript/Reference/Statements/let"><code>let</code></a> declarations has been implemented. In conformance with ES2015 <code>let</code> semantics, the following situations<br>
  now throw errors. See also this<a href="https://groups.google.com/forum/#!topic/mozilla.dev.platform/tezdW299Zds"> newsgroup announcement</a> and {{bug(1001090)}}.

  <ul>
   <li>Redeclaring existing variables or arguments using <code>let</code> within the same scope in function bodies is now a syntax error.</li>
   <li>Using a variable declared using <code>let</code> in function bodies before the declaration is reached and evaluated is now a runtime error.</li>
  </ul>
 </li>
 <li>ES2015 {{jsxref("Symbols")}} (only available in the Nightly channel) have been updated to conform with recent specification changes:
  <ul>
   <li><code>String(Symbol("1"))</code> now no longer throws a {{jsxref("TypeError")}}; instead a string (<code>"Symbol(1)"</code>) gets returned ({{bug(1058396)}}).</li>
  </ul>
 </li>
 <li>The various <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/TypedArray#TypedArray_objects"><em>TypedArray</em> constructors</a> now have as their <code>[[Prototype]]</code> a single function, denoted <code>%TypedArray%</code>  in ES2015 (but otherwise not directly exposed).  Each typed array prototype now inherits from <code>%TypedArray%.prototype</code>.  (<code>%TypedArray%</code> and <code>%TypedArray%.prototype</code> inherit from <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function/prototype"><code>Function.prototype</code></a> and <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/prototype"><code>Object.prototype</code></a>, respectively, so that typed array constructors and instances still have the properties found on those objects.)  Typed array function properties now reside on <code>%TypedArray%.prototype</code> and work on any typed array.  See <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/TypedArray#Description"><em>TypedArray</em></a> and {{bug(896116)}} for more information.</li>
 <li>ES2015 semantics for <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Object_initializer#Prototype_mutation">prototype mutations using object literals</a> have been implemented ({{bug(1061853)}}).
  <ul>
   <li>Now only a single member notated as <code>__proto__:value</code> will mutate the <code>[[Prototype]]</code> in the object literal syntax.</li>
   <li>Method members like <code>__proto__() {}</code> will not overwrite the <code>[[Prototype]]</code> anymore.</li>
  </ul>
 </li>
</ul>

<h3 id="InterfacesAPIsDOM">Interfaces/APIs/DOM</h3>

<ul>
 <li>The {{domxref("NavigatorLanguage")}} interface is now available to workers on {{domxref("WorkerNavigator")}} ({{bug(925849)}}).</li>
 <li>The {{domxref("Element.closest()")}} method returns the closest ancestor of the current element ({{bug(1055533)}}).</li>
 <li>Experimental support for the {{domxref("CanvasRenderingContext2D.filter")}} property has been added behind the <code>canvas.filters.enabled</code> flag ({{bug(927892)}}).</li>
 <li>Our experimental implementation of Web Animations progresses with the landing of the {{domxref("Animation.target")}} property. This always is behind the <code>dom.animations-api.core.enabled</code> pref, off by default ({{bug(1067701)}}).</li>
 <li>The {{domxref("Element.hasAttributes", "hasAttributes()")}} method has been moved from {{domxref("Node")}} to {{domxref("Element")}} as required by the spec ({{bug("1055773")}}).</li>
 <li>The <code>crossOrigin</code> reflected attribute of {{domxref("HTMLImageElement")}}, {{domxref("HTMLLinkElement")}}, {{domxref("HTMLMediaElement")}}, {{domxref("HTMLScriptElement")}}, and {{domxref("SVGScriptElement")}} only accepts valid values, and <code>""</code> isn't, <code>null</code> has to be used instead ({{bug(880997)}}).</li>
 <li>The Resource Timing API has been activated by default ({{bug(1002855)}}).</li>
 <li>To match the spec, the first argument of {{domxref("Selection.containsNode()")}} cannot be <code>null</code> anymore ({{bug(1068058)}}).</li>
 <li>The new {{domxref("ImageCapture")}} API has been implemented: {{domxref("ImageCapture.takePhoto()")}} is available ({{bug(916643)}}).</li>
 <li>Non-HTTP {{domxref("XMLHttpRequest")}} requests now return <code>200</code> in case of success (instead of the erroneous <code>0</code>) ({{bug(716491)}}).</li>
 <li>{{domxref("XMLHttpRequest.responseURL")}} has been adapted to the latest spec and doesn't include the fragment (<code>'#xyz'</code>) of the URL, if relevant ({{bug(1073882)}}).</li>
 <li>The internal, non-standard, {{domxref("File.mozFullPath")}} property is no more visible from content ({{bug(1048293)}}).</li>
 <li>The constructor of {{domxref("File")}} has been extended to match the specification ({{bug(1047483)}}).</li>
 <li>An experimental implementation of {{domxref("AbortablePromise")}}, a promise that can be aborted by a different entity that the one who created it, has been added. It is prefixed with <code>Moz</code> and controlled by the <code>dom.abortablepromise.enabled </code>property, defaulting to <code>false</code> ({{bug(1035060)}}).</li>
 <li>The non-standard {{domxref("Navigator.mozIsLocallyAvailable")}} property has been removed ({{bug(1066826)}}).</li>
 <li>The preference <code>network.websocket.enabled,</code> <code>true</code> by default, has been removed; <a href="/en-US/docs/WebSockets">Websocket</a> API cannot be deactivated anymore ({{bug(1091016)}}).</li>
 <li>The non-standard methods and properties of {{domxref("Window.crypto")}} have been removed ({{bug(1030963)}}). Only methods and properties defined in the standard WebCrypto API are left.</li>
 <li>Our experimental implementation of WebGL 2.0 is going forward!
  <ul>
   <li>The {{domxref("WebGL2RenderingContext.copyBufferSubData()")}} method has been implemented ({{bug(1048668)}}).</li>
  </ul>
 </li>
</ul>

<h3 id="MathML">MathML</h3>

<ul>
 <li>The <code>dtls</code> OpenType feature (via the CSS {{cssxref("font-feature-settings")}} on the default stylesheet) is now applied automatically to MathML elements when positioning scripts over it (e.g. dotless i with mathematical hat).</li>
</ul>

<h3 id="SVG">SVG</h3>

<p><em>No change.</em></p>

<h3 id="AudioVideo">Audio/Video</h3>

<p><em>No change.</em></p>

<h2 id="Network_Security">Network &amp; Security</h2>

<ul>
 <li>HTTP/2 has been implemented and activated, with AEAD ciphers only ({{bug(1027720)}}) and ({{bug('1047594')}}).</li>
 <li>The HTTP/2 <code>alt-svc</code> header is now supported ({{bug(1003448)}}).</li>
 <li>The <a href="/en-US/docs/Web/Security/Public_Key_Pinning">Public Key Pinning</a> Extension for HTTP (HPKP) has been implemented ({{bug(787133)}}).</li>
 <li>The <a href="/en-US/docs/Web/Security/CSP">CSP</a> 1.1 <code>base-uri</code> <a href="/en-US/docs/Web/Security/CSP/CSP_policy_directives">directive</a> is now supported ({{bug(1045897)}}).</li>
 <li>Path of the source is now considered too when host-source matching happens in <a href="/en-US/docs/Web/Security/CSP">CSP</a> ({{bug(808292)}}).</li>
</ul>

<h2 id="Changes_for_add-on_and_Mozilla_developers">Changes for add-on and Mozilla developers</h2>

<h3 id="XUL_Add-ons">XUL &amp; Add-ons</h3>

<ul>
 <li>The private <code>_getTabForBrowser()</code> method on the <code><a href="/en-US/docs/Mozilla/Tech/XUL/tabbrowser">&lt;xul:tabbrowser&gt;</a></code> element has been deprecated. In its place, we've added a new, public, method called <span id="m-getTabForBrowser"><code><a href="/en-US/docs/Mozilla/Tech/XUL/Method/getTabForBrowser">getTabForBrowser</a></code></span>. This returns, predictably, the <code><a href="/en-US/docs/Mozilla/Tech/XUL/tab">&lt;xul:tab&gt;</a></code> element that contains the specified <code><a href="/en-US/docs/Mozilla/Tech/XUL/browser">&lt;xul:browser&gt;</a></code>.</li>
 <li><code>Components.utils.now()</code>, matching {{domxref("Performance.now()")}} has been implemented for non-window chrome code ({{bug(969490)}}).</li>
</ul>

<h3 id="Add-on_SDK">Add-on SDK</h3>

<h4 id="Highlights">Highlights</h4>

<ul>
 <li>Added <a href="https://developer.mozilla.org/en-US/Add-ons/SDK/Tutorials/Add_a_Context_Menu_Item#Adding_an_access_key">access keys for context menu</a>.</li>
 <li>Removed <code>isPrivateBrowsing</code> from <a href="https://developer.mozilla.org/en-US/Add-ons/SDK/High-Level_APIs/windows#BrowserWindow"><code>BrowserWindow</code></a>.</li>
 <li>added <code><a href="/en-US/Add-ons/SDK/High-Level_APIs/url#toJSON%28%29">toJSON</a> </code>method to <code>URL</code> instances from <a href="/en-US/Add-ons/SDK/High-Level_APIs/url">sdk/url</a></li>
</ul>

<h4 id="Details">Details</h4>

<p><a class="external external-icon" href="https://github.com/mozilla/addon-sdk/compare/firefox34...firefox35">GitHub commits made between Firefox 34 and Firefox 35</a>. This will not include any uplifts made after this release entered Aurora.</p>

<p><a class="external external-icon" href="https://bugzilla.mozilla.org/buglist.cgi?resolution=FIXED&amp;chfieldto=2014-10-13&amp;chfield=resolution&amp;query_format=advanced&amp;chfieldfrom=2014-09-02&amp;chfieldvalue=FIXED&amp;bug_status=RESOLVED&amp;bug_status=VERIFIED&amp;bug_status=CLOSED&amp;product=Add-on%20SDK&amp;list_id=11562840">Bugs fixed between Firefox 34 and Firefox 35</a>. This will not include any uplifts made after this release entered Aurora.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://www.fxsitecompat.com/en-US/versions/35/">Site Compatibility for Firefox 35</a></li>
</ul>

<h2 id="Older_versions">Older versions</h2>

<p>{{Firefox_for_developers('34')}}</p>
